package org.lixm.optional.v16.framework.rpf.pipeline.hybrid;

import org.lixm.core.common.LIXMException;
import org.lixm.core.list.XMLCursor;
import org.lixm.core.list.XMLDocumentList;
import org.lixm.core.model.AbstractModel;
import org.lixm.optional.v15.atattch.XMLDispatcher;
import org.lixm.optional.v15.atattch.XMLReceiver;


/**
 * nCubhA[LeN`ɂpCvCłB
 * @author tasogare
 * @version 1.7.0
 * @since 1.6.1
 *
 * @param <E> f^
 */
public class HybridPipeLine <E extends AbstractModel>{

	class DefaultDispatcher implements XMLDispatcher {

    	XMLDocumentList<E> list;
    	XMLCursor cursor;

    	DefaultDispatcher(XMLDocumentList<E> list){
    		this.list = list;
    		cursor = list.getCursor( );
    		cursor.resetIndex( );
    	}

    	public void dispath(
	        XMLReceiver receiver) throws LIXMException
	    {
    		receiver.receive(list.get(cursor.inc( )));
	    }

	    public void dispath() throws LIXMException,
	        UnsupportedOperationException
	    {
	    	throw new AssertionError(
	    		"DefaultDispatcher#dispath(XMLReceiver)ĂяoĂB");
	    }

    }

	XMLDispatcher dispatcher;
	XMLReceiver receiver;
	XMLDocumentList<E> list;

	private HybridPipeLine(){}

	/**
	 * <p>ftHg̃fBXpb`𗘗pRXgN^łB</p>
	 * @param list fXg
	 * @param receiver V[o
	 */
	public  HybridPipeLine(XMLDocumentList<E> list, XMLReceiver receiver){
		this.list = list;
		this.receiver = receiver;
		this.dispatcher = new DefaultDispatcher(list);
	}

	/**
	 * <p>Cӂ̃fBXpb`𗘗pRXgN^łB</p>
	 * @deprecated 
	 * @param list fXg
	 * @param receiver V[o
	 * @param dispatcher fBXpb`
	 */
	@Deprecated public  HybridPipeLine(XMLDocumentList<E> list, XMLReceiver receiver, XMLDispatcher dispatcher){
		this.list = list;
		this.receiver = receiver;
		this.dispatcher = dispatcher;
	}

	/**
	 * vɂfBXpb`烌V[oփf𑗂܂B
	 * @throws LIXMException ɗOꍇ
	 */
	public void pull() throws LIXMException{
		this.dispatcher.dispath(this.receiver);
	}

	/**
	 * vbVɂfBXpb`烌V[oփf𑗂܂B
	 * @param count vbV
	 * @throws LIXMException ɗOꍇ
	 */
	public void push(int count) throws LIXMException{
		for(int i=0; i < count + 1; i++){
			this.dispatcher.dispath(this.receiver);
		}
	}

}
